﻿Imports System.IO
Imports System.Text
Public Class Form1
    Private d = New cubepuzzle
    Private solve As Boolean = False
    Private temporyfile(1) As String
    Private Sub partbox_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        If solve Then Exit Sub
        Dim C_left As Boolean  'mouse left clicked
        Dim C_right As Boolean  'mouse right clicked
        If e.Button = Windows.Forms.MouseButtons.Left Then C_left = True
        If e.Button = Windows.Forms.MouseButtons.Right Then C_right = True
        d.shaderect(e.Y, e.X, C_left, C_right) 'input to bitmap and puzzle array
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim partbox As New PictureBox
        partbox = d.picbox(False)
        Me.Controls.Add(partbox)
        d.enter_part()
        partbox.Image = d.partentrymap.clone
        d.npartnumber = d.npartnumber + 1
        d.partentrymap() 'update map
    End Sub
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Try  'delete tempory files if they wre used
            File.Delete(temporyfile(0))
            File.Delete(temporyfile(1))
        Catch ex As Exception
        End Try
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        d.fast = True
        d.wide = Me.Width
        d.high = Me.Height
        Dim partbox As New PictureBox
        partbox = d.picbox(True)
        Me.Controls.Add(partbox)
        AddHandler partbox.MouseMove, AddressOf partbox_MouseMove
        partbox.Image = d.partentrymap
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Button2.Enabled = False
        Button1.Enabled = False
        solve = True
        d.solve_puzzle()
    End Sub
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        SyncLock d.part  'ensure not using same time as solution worker thread
            Me.Refresh()
        End SyncLock
    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        temporyfile(0) = Path.GetTempFileName & "ipz.mht"
        My.Computer.FileSystem.WriteAllBytes(temporyfile(0), My.Resources.Impuzzables, False)
        Try
            Process.Start(temporyfile(0))
        Catch ex As Exception
            MessageBox.Show("Cant display this document")
        End Try
    End Sub
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        temporyfile(1) = Path.GetTempFileName & "ipz.mht"
        My.Computer.FileSystem.WriteAllBytes(temporyfile(1), My.Resources.information, False)
        Try
            Process.Start(temporyfile(1))
        Catch ex As Exception
            MessageBox.Show("Cant display this document")
        End Try
    End Sub
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Form2.Show()
    End Sub
    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        If RadioButton1.Checked = True Then d.fast = False Else d.fast = True
    End Sub
    Private Sub LinkLabel1_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles LinkLabel1.LinkClicked
        e.Link.Visited = True
        Dim url As String = "http://www.geocities.com/c.morey47/"
        Try
            Process.Start(url)
        Catch ex As Exception
            MessageBox.Show("Cant connect to this site")
        End Try
    End Sub
End Class
